/****************************************************************************
 * Projekt - Messtechnik 1
 * (c) 2017 softwareentwicklung-als-prozess.de
 * Dokumentation s. Blog
 * Funktionalitaet:
 * Aufbau und Nutzung der Verbindung zum MQTT Server
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <Ethernet.h>
#include <PubSubClient.h>
#include "mqttclient.h"
#include "getfunctions.h"

// Variablen -----------------------------------------------------------------
static byte mac[] = {0x90, 0xA2, 0xDA, 0x10, 0x4f, 0x45}; // Ethernet MAC Adresse
static IPAddress    pscsrv(192, 168, 198, 21);            // IP Adresse des MQTT Servers
static unsigned int pscport = 1883;                       // MQTT Port
EthernetClient Ether;
PubSubClient pscclient(Ether);

// Funktionen ---------------------------------------------------------------
boolean MQTTSetup(void)
{
  if (Ethernet.begin(mac) == 0) // Fehlerfall
  {
    return(false);
  }
  else
  {
    pscclient.setServer(pscsrv, pscport);
    return(true);
  }
}

byte MQTTGetIPAddress(byte bno)
{
  return(Ethernet.localIP()[bno]);
}

void MQTTConnectAndPublish(void)
{
  char tmpstr[50];
  
  if (pscclient.connect("JGE-TL")) 
  {
    Serial.println("MQTT verbunden");
    
    // Nach dem connect folgen die Topics
    sprintf(tmpstr,"%6u",(unsigned int)Get_Spannung());  // Messwert umwandeln in ASCII String
    pscclient.publish("Sensor1/Spannung/Messwert/mV",tmpstr);
    switch(Get_Status())
    {
      case Normal:
        strcpy(tmpstr,"Normaler Betrieb");
        break;
      case Eingeschraenkt:
        strcpy(tmpstr,"Eingeschraenkter Betrieb");
        break;
      case BO_Resume:
        strcpy(tmpstr,"Eingeschraenkter Betrieb / Brown Out ueberstanden");
        break;
      case BO_Warnung:
        strcpy(tmpstr,"Brown Out Warnung!");
        break;    
    }
    pscclient.publish("Sensor1/Batterie/Status",tmpstr);
  } 
  else 
  {
    Serial.print("MQTT failed, status = ");
    Serial.print(pscclient.state());
    Serial.println();
  }
}


